# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b320"
os.chdir("/Users/was/.sage/sage_notebook/worksheets/admin/38/cells/16")
sage.server.notebook.interact.SAGE_CELL_ID=16
_sage_const_2 = Integer(Integer(2)); _sage_const_1 = Integer(Integer(1)); _sage_const_0 = Integer(Integer(0))
def sign(n):
    if n > _sage_const_0 :
        return +_sage_const_1
    elif n < _sage_const_0 :
        return -_sage_const_1
    return _sage_const_0
def sturm_sig(T):
    """
    INPUT:
        T -- irreducible poly with integer coefficients
    OUTPUT:
        r1, r2 -- signature of T, i.e., number of real and complex-conjugate pairs of roots
    """
    Z = ZZ['x']
    T = Z(T)

    # Step 1: Initializations and reductions
    if T.degree() == _sage_const_0 :
        return _sage_const_0 ,_sage_const_0
    A = T // T.content()
    Tprime = T.derivative()  # slow because not optimized
    B = Tprime // Tprime.content()
    g = _sage_const_1
    h = _sage_const_1
    s = sign(A.leading_coefficient())
    n = A.degree()
    t = (-_sage_const_1 )**(n-_sage_const_1 ) * s
    r1 = _sage_const_1
    while True:
        # Step 2: Pseudo division
        delta = A.degree() - B.degree()
        Q, R, d = A.pseudo_divrem(B)  # I had to add this to Sage -- see trac #5222
        if d != delta+_sage_const_1 :
            scale = B.leading_coefficient()**(delta + _sage_const_1  - d)
            Q, R = scale*Q, scale*R
        if R == _sage_const_0 :
            raise ValueError, "input T is not square free"
        if B.leading_coefficient() > _sage_const_0  or delta % _sage_const_2 :
            R = -R

        # Step 3: Use Sturm
        sR = sign(R.leading_coefficient())
        if sR != s:
            s  = -s
            r1 = r1 - _sage_const_1
        if sR != (-_sage_const_1 )**R.degree() * t:
            t = -t
            r1 = r1 + _sage_const_1

        # Step 4: Finished
        if R.degree() == _sage_const_0 :
            return r1, (n-r1)//_sage_const_2
        else:
            A = B
            B = R//(g*h**delta)
            g = abs(A.leading_coefficient())
            h = h**(_sage_const_1 -delta) * g**delta

print "e320"
